function vexrunes.panel_layout()
	return {
		type = "group",
		args = {			
			texture = {
				name = "Background texture",
				order=1, type = "select", width="double",
				dialogControl = "LSM30_Background",
				desc = "Sets the frame's background",
				values = vexpower.LSM:HashTable("background"),
				set = function(self,key) vexrunes_parameters["layout"]["runes"]["bg"]["texture"]=key vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["runes"]["bg"]["texture"] end,
				},
			background = {
				name = "Color for the background that is shown when a rune is reloading",
				order=2, type = "color", hasAlpha=true, width="double",
				desc = "Color for the background that is shown when a rune is reloading",
				set = function(info,r,g,b,a)
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["r"]=r
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["g"]=g
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["b"]=b
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["a"]=a
					vexrunes_initialize(true) end,
				get = function() return 
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["r"],
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["g"],
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["b"],
					vexrunes_parameters["layout"]["runes"]["bg"]["shadow"]["a"] end,
				},
			shadowdefault = {
				name = "set to default",
				desc = "set to default",
				order=3, type = "execute",
				func = function(info,val) vexrunes_load_color("shadow") vexrunes_initialize(true) end,
				},
			usedcolor = {
				name = "Color for the blink when a rune has been used",
				order=5, type = "color", hasAlpha=true, width="double",
				desc = "Color for the blink when a rune has been used",
				set = function(info,r,g,b,a)
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["r"]=r
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["g"]=g
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["b"]=b
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["a"]=a
					vexrunes_initialize(true) end,
				get = function() return 
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["r"],
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["g"],
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["b"],
					vexrunes_parameters["layout"]["runes"]["bg"]["used"]["a"] end,
				},
			useddefault = {
				name = "set to default",
				desc = "set to default",
				order=6, type = "execute",
				func = function(info,val) vexrunes_load_color("used") vexrunes_initialize(true) end,
				},
			runecolors = {name = "Rune Colors", type="header", order=10},
			blood = {
				name = "Blood Rune",
				order=11, type = "color", hasAlpha=true, width="double",
				desc = "Color for the blood Rune",
				set = function(info,r,g,b,a)
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["r"]=r
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["g"]=g
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["b"]=b
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["a"]=a
					vexrunes_initialize(true) end,
				get = function() return 
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["r"],
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["g"],
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["b"],
					vexrunes_parameters["layout"]["runes"]["bg"]["blood"]["a"] end,
				},
			blooddefault = {
				name = "set to default",
				desc = "set to default",
				order=12, type = "execute",
				func = function(info,val) vexrunes_load_color("blood") vexrunes_initialize(true) end,
				},
			frost = {
				name = "Frost Rune",
				order=20, type = "color", hasAlpha=true, width="double",
				desc = "Color for the frost Rune",
				set = function(info,r,g,b,a)
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["r"]=r
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["g"]=g
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["b"]=b
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["a"]=a
					vexrunes_initialize(true) end,
				get = function() return 
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["r"],
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["g"],
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["b"],
					vexrunes_parameters["layout"]["runes"]["bg"]["frost"]["a"] end,
				},
			frostdefault = {
				name = "set to default",
				desc = "set to default",
				order=22, type = "execute",
				func = function(info,val) vexrunes_load_color("frost") vexrunes_initialize(true) end,
				},
			unholy = {
				name = "Unholy Rune",
				order=30, type = "color", hasAlpha=true, width="double",
				desc = "Color for the unholy Rune",
				set = function(info,r,g,b,a)
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["r"]=r
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["g"]=g
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["b"]=b
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["a"]=a
					vexrunes_initialize(true) end,
				get = function() return 
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["r"],
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["g"],
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["b"],
					vexrunes_parameters["layout"]["runes"]["bg"]["unholy"]["a"] end,
				},
			unholydefault = {
				name = "set to default",
				desc = "set to default",
				order=32, type = "execute",
				func = function(info,val) vexrunes_load_color("unholy") vexrunes_initialize(true) end,
				},
			death = {
				name = "Death Rune",
				order=40, type = "color", hasAlpha=true, width="double",
				desc = "Color for the death Rune",
				set = function(info,r,g,b,a)
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["r"]=r
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["g"]=g
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["b"]=b
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["a"]=a
					vexrunes_initialize(true) end,
				get = function() return 
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["r"],
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["g"],
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["b"],
					vexrunes_parameters["layout"]["runes"]["bg"]["death"]["a"] end,
				},
			deathdefault = {
				name = "set to default",
				desc = "set to default",
				order=42, type = "execute",
				func = function(info,val) vexrunes_load_color("death") vexrunes_initialize(true) end,
				},
				
				
			textheader = {name = "Cooldown text", type="header", order=100},
			showtext = {
				name = "Show cooldown-text",
				order=101, type = "toggle", width="full",
				desc = "Show",
				set = function(self,key) vexrunes_parameters["layout"]["text"]["show"]=key vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["text"]["show"] end,
				},
			textfont = {
				name = "Text font",
				order=105, type = "select",
				dialogControl = "LSM30_Font",
				desc = "Sets the font for the text",
				values = vexrunes.LSM:HashTable("font"),
				set = function(self,key) vexrunes_parameters["layout"]["text"]["font"]=key vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["text"]["font"] end,
				},
			textsize = {
				name = "Text Size",
				order=106, type = "range",
				desc = "Sets the font size for the messages",
				step = 1, min = 6, max = 20,
				set = function(info,val) vexrunes_parameters["layout"]["text"]["size"]=val vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["text"]["size"] end,
				},
			textalign = {
				name = "Text align",
				order=107, type = "select", style = "dropdown",
				desc = "Sets the text align",
				values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
				set = function(self,key) vexrunes_parameters["layout"]["text"]["align"]=key vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["text"]["align"] end,
				},
			textcolor = {
				name = "Text color",
				order=108, type = "color", hasAlpha=true, width="full",
				desc = "Text color",
				set = function(info,r,g,b,a)
					vexrunes_parameters["layout"]["text"]["color"]["r"]=r
					vexrunes_parameters["layout"]["text"]["color"]["g"]=g
					vexrunes_parameters["layout"]["text"]["color"]["b"]=b
					vexrunes_parameters["layout"]["text"]["color"]["a"]=a
					vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["text"]["color"]["r"],
					vexrunes_parameters["layout"]["text"]["color"]["g"],
					vexrunes_parameters["layout"]["text"]["color"]["b"],
					vexrunes_parameters["layout"]["text"]["color"]["a"] end,
				},
			textx = {
				name = "X Position",
				order=109, type = "range",
				desc = "Sets the x position",
				step = 1, min = -100, max = 100,
				set = function(info,val) vexrunes_parameters["layout"]["text"]["x"]=val vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["text"]["x"] end,
				},
			texty = {
				name = "Y Position",
				order=110, type = "range",
				desc = "Sets the y position",
				step = 1, min = -100, max = 100,
				set = function(info,val) vexrunes_parameters["layout"]["text"]["y"]=val vexrunes_initialize(true) end,
				get = function() return vexrunes_parameters["layout"]["text"]["y"] end,
				},
			}
		}
end

function vexrunes_load_color(color)
	vexrunes_parameters["layout"]["runes"]["bg"][color]["r"]=vexrunes_defaults["layout"]["runes"]["bg"][color]["r"]
	vexrunes_parameters["layout"]["runes"]["bg"][color]["g"]=vexrunes_defaults["layout"]["runes"]["bg"][color]["g"]
	vexrunes_parameters["layout"]["runes"]["bg"][color]["b"]=vexrunes_defaults["layout"]["runes"]["bg"][color]["b"]
	vexrunes_parameters["layout"]["runes"]["bg"][color]["a"]=vexrunes_defaults["layout"]["runes"]["bg"][color]["a"]
end


